=== modified file 'src/com/goldencode/p2j/uast/SymbolResolver.java'
--- old/src/com/goldencode/p2j/uast/SymbolResolver.java	2021-02-19 21:59:06 +0000
+++ new/src/com/goldencode/p2j/uast/SymbolResolver.java	2021-04-13 20:38:28 +0000
@@ -443,6 +443,9 @@
 **                           involved in dynamic or static OO calls, functions or procedure calls.  This 
 **                           includes mostly cases for OO properties/variables (static and non-static).
 **     OM  20210219          lookupWorkerExact returns -1 if null dictionary is provided instead of NPE.
+**     GES 20210413          Added lookupTableInfo() to reduce the number of name node lookups. Reworked
+**                           translateType() to properly handle buffers, tables, datasets, table-handles,
+**                           dataset-handles and objects.
 */
 
 /*
@@ -1296,14 +1299,7 @@
             {
                if (parm.getType() == PARAMETER)
                {
-                  String name = translateType((int) ((long) parm.getAnnotation("type")), parm);
-                  
-                  if ("object".equals(name) || "jobject".equals(name))
-                  {
-                     String qual = (String) parm.getAnnotation("qualified");
-                     
-                     name = String.format("%s<? extends %s>", name, qual);
-                  }
+                  String name = translateType((int) ((long) parm.getAnnotation("type")), parm, null);
                   
                   name = formatExtentName(name, readExtent(parm));
                   
@@ -1560,11 +1556,8 @@
       
       if (stype == DEFINE_PROPERTY)
       {
-         String ptype = translateType(var.getTokenType(), null);
-         if ("object".equals(ptype) && var.getClassName() != null)
-         {
-            ptype = "object<? extends " + var.getClassName() + ">";
-         }
+         String ptype = translateType(var.getTokenType(), null, var.getClassName());
+         
          if (var.isExtent())
          {
             String ext = var.isExtent() 
@@ -1709,10 +1702,12 @@
     *           The token type representing a variable/parameter type. 
     * @param    parm
     *           The PARAMETER node which is used to extract the type of this parameter.
+    * @param    qualified
+    *           Fully qualified object classname or {@code null} if no qualifier is needed. 
     *
     * @return   The wrapper class name.
     */
-   public static String translateType(int type, Aast parm)
+   public static String translateType(int type, Aast parm, String qualified)
    {
       if (parm != null)
       {
@@ -1778,22 +1773,49 @@
             break;
          case VAR_CLASS:
             cls = "object";
+            
+            String qual = qualified;
+            
             if (parm != null)
             {
                if (parm.isAnnotation("is-java") && (Boolean) parm.getAnnotation("is-java"))
                {
                   cls = "jobject";
                }
+               
+               if (qualified == null)
+               {
+                  qual = (String) parm.getAnnotation("qualified");
+               }
             }
+            
+            cls = String.format("%s<? extends %s>", cls, qual);
             break;
             
-         // TABLE and BUFFER parameters - these will have the TABLE or BUFFER prefix,
-         // followed by the schemaname.
+         // TABLE and BUFFER parameters - these will have the TEMP-TABLE or BUFFER prefix,
+         // followed by the schemaname or other details that make the table unambigous
          case KW_TABLE:
             ref = parm.getType() == KW_TABLE ? parm : parm.getImmediateChild(KW_TABLE, null);
             ref = ref.getImmediateChild(TEMP_TABLE, null);
+            
+            if (ref == null)
+            {
+               // this is unexpected since permanent tables and work-tables should not be possible here
+               // and buffers are handled below
+               throw new RuntimeException(String.format("TABLE parameters should be temp-tables: %s",
+                                                        parm.dumpTree()));
+            }
+            
+            String signature = (String) ref.getAnnotation("signature");
+            
+            if (signature == null)
+            {
+               throw new RuntimeException(String.format("Missing 'signature' annotation in: %s",
+                                                        ref.dumpTree()));
+            }
+            
             // for temp-tables, the compile time mapping is done via the table's field signature
-            cls = "TEMP-TABLE";
+            cls = String.format("TEMP-TABLE <%s>", signature);
             break;
          case KW_BUFFER:
             ref = parm.getType() == KW_BUFFER ? parm : parm.getImmediateChild(KW_BUFFER, null);
@@ -1805,18 +1827,51 @@
             if (ref.getType() == TEMP_TABLE || 
                 (ref.getType() == BUFFER && "".equals(ref.getAnnotation("dbname"))))
             {
-               cls = "BUFFER <temp-table>";
+               String tabname = (String) ref.getAnnotation("schemaname");
+               String tabsig  = (String) ref.getAnnotation("signature");
+               
+               if (tabsig == null)
+               {
+                  throw new RuntimeException(String.format("Missing 'signature' annotation in: %s",
+                                                           ref.dumpTree()));
+               }
+               
+               cls = String.format("BUFFER <temp-table %s <%s>>", tabname.toLowerCase(), tabsig);
             }
             else
             {
-               cls = String.format("BUFFER %s", ref.getAnnotation("schemaname"));
+               cls = String.format("BUFFER <%s>", ref.getAnnotation("schemaname"));
             }
             break;
          case KW_DATASET:
-            cls = "DATASET";
+            ref = parm.getType() == KW_DATASET ? parm : parm.getImmediateChild(KW_DATASET, null);
+            
+            if (ref == null)
+            {
+               throw new RuntimeException(String.format("Missing KW_DATASET in: %s", parm.dumpTree()));
+            }
+            
+            ref = (Aast) ref.getFirstChild();
+            
+            if (ref == null || ref.getType() != DATA_SET)
+            {
+               throw new RuntimeException(String.format("Missing DATA_SET in: %s", parm.dumpTree()));
+            }
+            
+            String sig = (String) ref.getAnnotation("signature");
+            
+            if (sig == null)
+            {
+               throw new RuntimeException(String.format("Missing 'signature' annotation in: %s",
+                                                        ref.dumpTree()));
+            }
+            
+            cls = String.format("DATASET %s", sig);
             break;
          case KW_DATA_SRC:
-            // TODO: example with this as parameter and argument?
+            // TODO: as far as I know, this is not possible; dump some data so we can generate an example 
+            //       with this as parameter and argument
+            System.err.printf("WARNING: UNEXPECTED DATA-SOURCE PARAMETER %s\n", parm.dumpTree());
             cls = "DATA-SOURCE";
             break;
       }
@@ -1870,10 +1925,11 @@
                 type != KW_BY_VALUE)
             {
                String cls = ExpressionConversionWorker.expressionType(parm, false, false);
-               
-               if ("Buffer".equalsIgnoreCase(cls))
+
+               // this is not just buffers, it is also any form of table reference except for table-handle
+               if ("Buffer".equalsIgnoreCase(cls) || "DATASET".equalsIgnoreCase(cls))
                {
-                  cls = translateType(parm.getType(), parm);
+                  cls = translateType(parm.getType(), parm, null);
                }
                else
                {
@@ -4426,7 +4482,8 @@
       // annotateClassRef, but left here in case there are other situations added.
       if (qname == null)
       {
-         System.out.println("FAILURE: Retruning from annotateClassRef due null qname " + node.dumpTree(true));
+         System.out.println("FAILURE: Returning from annotateClassRef because of null qname " +
+                            node.dumpTree(true));
          return;
       }
       ClassDefinition cls = lookupClass(qname);
@@ -6797,7 +6854,7 @@
     * given the field's name and an optional table name-node.
     * 
     * @param   table
-    *          Name node asssociated with the field reference. If not {@code null}, only the
+    *          Name node associated with the field reference. If not {@code null}, only the
     *          private namespace of the given {@code table} is searched (for an exact match)
     *          of {@code fieldName}. If {@code null}, a lenient search (i.e., abbreviations
     *          permitted) is performed across all scopes in the schema dictionary.
@@ -6833,6 +6890,45 @@
    }
    
    /**
+    * Look up and return the table info instance which describes a database table in a schema.
+    *
+    * @param   name
+    *          Text string to match, exactly as found in the original source code
+    *          (abbreviated, qualified or unqualified). 
+    * @param   forceTemp
+    *          If <code>true</code>, force a temp-table lookup.
+    * @param   forcePersistent
+    *          If <code>true</code>, force a persistent table lookup.
+    *
+    * @return  The table info instance or <code>null</code> if no match was found.
+    */
+   public TableInfo lookupTableInfo(String name, boolean forceTemp, boolean forcePersistent)
+   {
+      TableInfo result = null;
+      
+      try
+      {
+         if (schemaDict != null)
+         {
+            SchemaHelper<TableInfo> info = (SchemaDictionary dict) -> 
+            {
+               return dict.findTableInfo(name, forceTemp, forcePersistent);
+            };
+               
+            Predicate<TableInfo> notNull = (TableInfo val) -> { return (val == null); };
+               
+            result = processHierarchy(info, notNull);
+         }
+      }
+      catch (SchemaException exc)
+      {
+         exc.printStackTrace();
+      }
+      
+      return result;
+   }
+   
+   /**
     * Look up and return the AST which represents a database field in a schema, given the field's
     * name.
     * 

=== modified file 'src/com/goldencode/p2j/uast/Variable.java'
--- old/src/com/goldencode/p2j/uast/Variable.java	2021-03-23 11:42:56 +0000
+++ new/src/com/goldencode/p2j/uast/Variable.java	2021-04-13 14:17:05 +0000
@@ -4,7 +4,7 @@
 **
 ** Copyright (c) 2005-2021, Golden Code Development Corporation.
 **
-** -#- -I- --Date-- --JPRM-- ----------------Description-----------------
+** -#- -I- --Date-- --JPRM-- ----------------------------------Description----------------------------------
 ** 001 GES 20050210   @19752 First version, simple bean-like approach.
 ** 002 GES 20050330   @20563 Added support for a large number of options
 **                           and helper methods to copy options and write
@@ -80,6 +80,7 @@
 ** 216 CA  20200429          Legacy DEFINE ENUM conversion support.
 ** 217 CA  20200804          Added getExtent().
 ** 218 CA  20210318          Fixed conversion of extent() function/statement with builtin OO properties.
+**     GES 20210413          Added dataset signature annotation processing.  Cleaned up some warnings.
 */
 
 /*
@@ -341,8 +342,6 @@
          Aast kwInit = copy.getImmediateChild(KW_INIT, null);
          if (kwInit != null && kwInit.getNumImmediateChildren() > 1)
          {
-            int size = kwInit.getNumImmediateChildren();
-            
             // Due to a bug in Progress 9.1c (and possibly other versions),
             // a temp-table field or var like some specific element of any
             // extent field/var always picks up the initial value of the
@@ -356,6 +355,8 @@
             Aast initTgt = kwInit.getChildAt(extent);
             if (initTgt == null)
             {
+               int size = kwInit.getNumImmediateChildren();
+               
                // We have more than one initializer value, but not enough
                // to match the index we were given, so use the last
                // available.
@@ -771,9 +772,10 @@
       }
       
       boolean isEnum = ast.getType() == ENUM_VALUE;
+      
       if (tempIdx != -1 && !builtin)
       {
-         ast.putAnnotation("tempidx", new Long(tempIdx));
+         ast.putAnnotation("tempidx", (long) tempIdx);
          if (clsDef != null)
          {
             ast.putAnnotation("tempidx-file", clsDef.getFilename());
@@ -804,7 +806,7 @@
       
       if (builtin)
       {
-         ast.putAnnotation("builtin", new Boolean(true));
+         ast.putAnnotation("builtin", true);
       }
       
       if (!original && clsDef != null)
@@ -815,7 +817,7 @@
       
       if (isProp)
       {
-         ast.putAnnotation("cls-property", new Boolean(true));
+         ast.putAnnotation("cls-property", true);
          ast.putAnnotation("cls-container", clsDef.getFilename());
       }
 
@@ -828,30 +830,51 @@
          // set default access mode (it will be overridden below if there is an
          // explicit mode specified
          access = isProp || isEnum || ast.getType() == DEFINE_EVENT ? KW_PUBLIC : KW_PRIVATE;
-         ast.putAnnotation("access-mode", new Long(access));
+         ast.putAnnotation("access-mode", (long) access);
+      }
+      
+      if (!original && ast.getType() == DATA_SET)
+      {
+         Aast ds = def.getImmediateChild(SYMBOL, null);
+         
+         if (ds == null)
+         {
+            throw new RuntimeException(String.format("Malformed dataset definition %s.", def.dumpTree()));
+         }
+         
+         String sig = (String) ds.getAnnotation("signature");
+         
+         if (sig == null)
+         {
+            throw new RuntimeException(String.format("Missing 'signature' annotation in dataset " +
+                                                     "definition %s.",
+                                                     def.dumpTree()));
+         }
+         
+         ast.putAnnotation("signature", sig);
       }
       
       if (!original && access != -1)
       {
          // access mode matters on the original definition, propagate it here
-         ast.putAnnotation("access-mode", new Long(access));
+         ast.putAnnotation("access-mode", (long) access);
       }
       
       if (isStatic || isEnum)
       {
-         ast.putAnnotation("static", new Boolean(true));
+         ast.putAnnotation("static", true);
       }
       
       if (extent != 0)
       {
-         ast.putAnnotation("extent", new Long(extent));
+         ast.putAnnotation("extent", (long) extent);
       }
       
       if (isEnum)
       {
          def = ast;
          ast.putAnnotation("name", name);
-         ast.putAnnotation("type", new Long(tokenType));
+         ast.putAnnotation("type", (long) tokenType);
          return;
       }
       
@@ -872,7 +895,7 @@
       
       if (tokenType != -1)
       {
-         ast.putAnnotation("type", new Long(tokenType));
+         ast.putAnnotation("type", (long) tokenType);
       }
       
       Aast child        = (Aast) def.getFirstChild();
@@ -908,23 +931,23 @@
             case KW_INPUT:
             case KW_IN_OUT:
             case KW_OUTPUT:
-               ast.putAnnotation("parmtype", new Long(ctype));
+               ast.putAnnotation("parmtype", (long) ctype);
                break;
             case KW_PUBLIC:
             case KW_PROTECTD:
             case KW_PRIVATE:
                // remember the explicit type
                access = ctype;
-               ast.putAnnotation("access-mode", new Long(ctype));
+               ast.putAnnotation("access-mode", (long) ctype);
                break;
             case KW_STATIC:
-               ast.putAnnotation("static", new Boolean(true));
+               ast.putAnnotation("static", true);
                break;
             case KW_ABSTRACT:
-               ast.putAnnotation("abstract", new Boolean(true));
+               ast.putAnnotation("abstract", true);
                break;
             case KW_OVERRIDE:
-               ast.putAnnotation("override", new Boolean(true));
+               ast.putAnnotation("override", true);
                break;
             case KW_FORMAT:
                grandchild = (Aast) child.getFirstChild();
@@ -978,7 +1001,7 @@
                               // save our changes
                               grandchild.setText(gtxt);
                               
-                              d = new Double(gtxt);
+                              d = Double.parseDouble(gtxt);
                            }
                            else if (gtype == HEX_LITERAL)
                            {
@@ -990,11 +1013,11 @@
                               
                               if (gtxt.length() == 0)
                               {
-                                 d = new Double(0);
+                                 d = (double) 0;
                               }
                               else
                               {
-                                 d = new Double(gtxt);
+                                 d = Double.parseDouble(gtxt);
                               }
                            }
                            else if (gtype == BOOL_TRUE || gtype == BOOL_FALSE)
@@ -1002,7 +1025,7 @@
                               // Progress silently accepts this initializer, we
                               // assume it is the same as 0 (no init), but this
                               // is untested at this time.
-                              d = new Double(0);
+                              d = (double) 0;
                            }
                         }
                         
@@ -1019,12 +1042,12 @@
                               // Progress allows decimal initializers for
                               // integers, in this case we must round to the
                               // nearest integer...
-                              Double dd = new Double(gtxt);
-                              l = new Long(Math.round(dd.doubleValue()));
+                              double dd = Double.parseDouble(gtxt);
+                              l = (long) Math.round(dd);
                            }
                            else if (gtype == NUM_LITERAL)
                            {
-                              l = new Long(gtxt);
+                              l = Long.parseLong(gtxt);
                            }
                            else if (gtype == HEX_LITERAL)
                            {
@@ -1036,11 +1059,11 @@
                               
                               if (gtxt.length() == 0)
                               {
-                                 l = new Long(0);
+                                 l = (long) 0;
                               }
                               else
                               {
-                                 l = new Long(gtxt);
+                                 l = Long.parseLong(gtxt);
                               }
                            }
                            else if (gtype == BOOL_TRUE ||
@@ -1049,7 +1072,7 @@
                               // Progress silently accepts this initializer,
                               // we assume it is the same as 0 (no init), but
                               // this is untested at this time.
-                              l = new Long(0);
+                              l = (long) 0;
                            }
                         }
                         
@@ -1142,7 +1165,7 @@
                int prec = ExpressionConversionWorker.literalToInt(child.getChildAt(0));
                if (tokenType == VAR_DEC && prec != 10)
                {
-                  ast.putAnnotation("decimals", new Long(prec));
+                  ast.putAnnotation("decimals", (long) prec);
                }
                break;
             case KW_EXTENT:
@@ -1189,7 +1212,7 @@
          if (ext != 0)
          {
             this.extent = ext;
-            ast.putAnnotation("extent", new Long(ext));
+            ast.putAnnotation("extent", (long) ext);
          }
       }
          
@@ -1290,6 +1313,21 @@
                                  ", format string = " + fmt + ") ");
       }
    }
+
+   /**
+    * Render the instance as text.
+    * 
+    * @return   The details of this instance as text.
+    */
+   public String toString()
+   {
+      return String.format("VARIABLE name %s; token type %d; extent %d; classname %s; AST %s",
+                           name,
+                           tokenType,
+                           extent,
+                           cls,
+                           def == null ? "null" : def.dumpTree());
+   }
    
    /**
     * Helper to copy a child subtree of a specific type from the source to

=== modified file 'src/com/goldencode/p2j/uast/progress.g'
--- old/src/com/goldencode/p2j/uast/progress.g	2021-03-18 19:11:30 +0000
+++ new/src/com/goldencode/p2j/uast/progress.g	2021-04-13 20:41:25 +0000
@@ -2183,6 +2183,9 @@
 **                           ENTITY-EXPANSION-LIMIT and XML-ENTITY-EXPANSION-LIMIT.
 **     EVL 20210305          Adding conversion support for rtf/docx related reports export.
 **     GES 20210318          Added undocumented abbreviation for SERVER-CONNECTION-CONTEXT.
+**     GES 20210413          Added signature calc/annotation to def_dataset_stmt. Reworked the record
+**                           annotations to be more efficient (to use lookupTableInfo()) and to add the
+**                           table signature annotation.
 */
 
 /*
@@ -13714,13 +13717,46 @@
          | KW_SERIALZH
          | KW_REF_ONLY
       )*
-      for_record_spec[false, false, false]
+      f:for_record_spec[false, false, false]
       ( 
          options { generateAmbigWarnings = false; }
          :
            data_relation[idx]       { idx++; }
          | parent_id_relation[pidx] { pidx++; }
       )*
+      {
+         Aast   child     = (Aast) #f.getFirstChild();
+         String signature = "";
+         
+         while (child != null)
+         {
+            int type = child.getType();
+         
+            if (type == BUFFER || type == TEMP_TABLE)
+            {
+               String s = (String) child.getAnnotation("signature");
+               
+               if (s == null)
+               {
+                  String err = String.format("Missing 'signature' for record: %s", child.dumpTree());
+                  throw new RuntimeException(err);
+               }
+               
+               signature += "<" + s + ">";
+            }
+            
+            child = (Aast) child.getNextSibling();
+         }
+         
+         if (signature.length() == 0)
+         {
+            String err2 = String.format("Missing 'signature' for dataset: %s", #ds.dumpTree());
+            throw new RuntimeException(err2);
+         }
+         
+         // annotate the SYMBOL node in the definition (will be the first child of DEFINE_DATASET) 
+         #d.putAnnotation("signature", signature);
+      }
    ;
    
 /**
@@ -26815,27 +26851,33 @@
       {
          // now store an annotation with the fully qualified name and the
          // shorted unabbreviated unique buffer name
-         String fullname = sym.lookupFullTableName(tablename, forceTemp, forcePersistent);
-         String bufname  = sym.lookupBufferName(tablename, false, forceTemp, forcePersistent);
-         String dbname   = sym.lookupDatabaseName(tablename, forceTemp, forcePersistent);
+         TableInfo info = sym.lookupTableInfo(tablename, forceTemp, forcePersistent);
                   
-         if (fullname != null)         
-            ##.putAnnotation("schemaname", fullname);
-            
-         if (bufname != null)
-            ##.putAnnotation("bufname", bufname);
-            
-         if (dbname != null)
-            ##.putAnnotation("dbname", dbname);
-            
-         // store the backing construct (this will be the same as the token
-         // type for every record type except buffers, in which case it will
-         // be TABLE, TEMP_TABLE or WORK_TABLE)
-         int backing = sym.lookupTableRecordType(tablename, forceTemp, forcePersistent);
-         
-         if (backing != -1)
+         if (info != null)
          {
-            ##.putAnnotation("recordtype", new Long(backing));
+            String sig      = info.getSignature();
+            String fullname = info.getQualified();
+            String bufname  = info.getBuffer();
+            String dbname   = info.getDatabase();
+            int    backing  = info.getRecordType();
+            
+            if (sig != null)
+               ##.putAnnotation("signature", sig);
+            
+            if (fullname != null)
+               ##.putAnnotation("schemaname", fullname);
+            
+            if (bufname != null)
+               ##.putAnnotation("bufname", bufname);
+               
+            if (dbname != null)
+               ##.putAnnotation("dbname", dbname);
+               
+            // store the backing construct (this will be the same as the token
+            // type for every record type except buffers, in which case it will
+            // be TABLE, TEMP_TABLE or WORK_TABLE)
+            if (backing != -1)
+               ##.putAnnotation("recordtype", new Long(backing));
          }
       }
    ;

